-- scripts folder
require("./scripts.Player")
require("./scripts.Menu")
require("./scripts.Animation")
require("./scripts.Tutorial")
require("./scripts.Background")
require("./scripts.Arrows")
-- platforms folder
require("./platforms.Floor")
require("./platforms.Platform_1")
require("./platforms.Platform_2")
require("./platforms.Platform_3")
require("./platforms.Thin_1")
require("./platforms.Thin_2")
require("./platforms.Thin_3")
require("./platforms.Thin_4")
require("./platforms.Thin_5")
require("./platforms.Thin_6")
require("./platforms.Boost_1")
require("./platforms.Long_1")
require("./platforms.Platform_loader")
-- libraries
tick = require("libraries.tick")

function love.load()
    -- loading configurations
    love.window.setMode(800, 600, {resizable = false})
    love.window.setTitle("Beyond the Rize 2")
    -- loading variables
    Level = 1
    Width = love.graphics.getWidth()
    Height = love.graphics.getHeight()
    a = 0
    cutsene = false
    -- loading other Thin_1gs
    Player:load()
    Menu:load()
    Floor:load()
    Platform_1:load()
    Platform_2:load()
    Platform_3:load()
    Animation:load()
    Background:load()
    Thin_1:load()
    Thin_2:load()
    Thin_3:load()
    Thin_4:load()
    Thin_5:load()
    Thin_6:load()
    Boost_1:load()
    Long_1:load()
    Tutorial:load()
    Arrows:load()
end

function love.update(dt)
    if love.keyboard.isDown("space") then 
        Level = Level + 1
    end
    Animation:update(dt)
    Platform_loader:update(dt)
    if Menu.transitionPlay then 
        transitionOn()
        if a >= 1 then 
            Menu.on = false
            Menu.transitionPlay = false
        end
    end
    if Menu.on then
        Menu:update(dt)
    elseif Menu.on == false then 
        transitionOff()
        if cutsene == false then 
            Player:update(dt)
        end
        Platform_1:update(dt)
        Platform_2:update(dt)
        Platform_3:update(dt)
        Thin_1:update(dt)
        Thin_2:update(dt)
        Thin_3:update(dt)
        Thin_4:update(dt)
        Thin_5:update(dt)
        Thin_6:update(dt)
        Boost_1:update(dt)
        Long_1:update(dt)
        Tutorial:update(dt)
        Arrows:update(dt)
        if Level == 1 then
            Floor:update(dt)
        end
    end
    if love.keyboard.isDown("escape") then
        love.event.quit()
    end
    if Level < 1 then
        Level = 1
    end
end

function love.draw()
    if Menu.on then
        Menu:draw()
    elseif Menu.on == false then 
        --[[if Level == 1 then 
            love.graphics.draw(Background1.Image)
        elseif Level == 2 then 
            love.graphics.draw(Background2.Image)
        end]]
        if cutsene == false then
            Player:draw()
        end
        Platform_1:draw()
        Platform_2:draw()
        Platform_3:draw()
        Thin_1:draw()
        Thin_2:draw()
        Thin_3:draw()
        Thin_4:draw()
        Thin_5:draw()
        Thin_6:draw()
        Boost_1:draw()
        Long_1:draw()
        Tutorial:draw()
        Arrows:draw()
        if Level == 1 then
            Floor:draw()
        end
    end
    love.graphics.print(love.timer.getFPS())
    love.graphics.print(Level, 30, 0)
    love.graphics.print(Player.boundDirection, 60, 0)
    love.graphics.setColor(0, 0, 0, a)
    love.graphics.rectangle("fill", 0, 0, 800, 600)
    love.graphics.setColor(1, 1, 1, 1)
end

-- collisions Thin_1g
function checkCollision(x1, y1, width1, height1, x2, y2, width2, height2)
    if x1 + width1 > x2 and x1 < x2 + width2 and y1 + height1 > y2 and y1 < y2 + height2 then
        return true
    else
        return false
    end
end

-- boundreis Thin_1g
function Player:bounds()
    if Player.ypos + Player.Height > love.graphics.getHeight() then
        Player.ypos = 0
        Level = Level - 1
    end
    if Player.ypos < 0 then
        Player.ypos = love.graphics.getHeight() - Player.Height
        Level = Level + 1
    end
    if Player.xpos + Player.Width > love.graphics.getWidth() then
        Player.xpos = love.graphics.getWidth() - Player.Width
    end
    if Player.xpos < 0 then
        Player.xpos = 0
    end
end

function Times64(num)
    if num == nil then
        num = 0
    end
    if num ~= 0 then
        num = 64 * num
        return num
    else
        return 0
    end
end

function love.keypressed(key)
    if Menu.on then
        if Menu.Mode == 1 then
            if key == "return" then
                if Menu.Select == 1 then
                    Menu.transitionPlay = true
                end
            end
        end
    end
end

-- transitions
function transitionOn()
    if a < 1 then
        a = a + 0.15
    end
end

function transitionOff()
    a = a - 0.1
end