Player = {}

function Player:load()
    Player.xpos = love.graphics.getWidth() / 2
    Player.ypos = love.graphics.getHeight() / 2
    Player.Width = 64
    Player.Height = 64
    Player.Gravity = 500
    Player.isJumping = false
    Player.Speed = 400
    Player.Image_1 = love.graphics.newImage("assets/Player/Player_1.png")
    Player.Image_2 = love.graphics.newImage("assets/Player/Player_2.png")
    Player.Image_3 = love.graphics.newImage("assets/Player/Player_3.png")
    Player.Image_4 = love.graphics.newImage("assets/Player/Player_2.png")
    Player.Image = Player.Image_1
    Player.collisionThin = true
    Player.isCollidingWithThin = false
    Player.isonPlatform = false
    Player.boundDirection = ""
    -- top hitbox
    Player.topx = Player.xpos + 10
    Player.topy = Player.ypos
    Player.topWidth = Player.Width - 20
    Player.topHeight = 10
    -- bottom hitbox
    Player.bottomx = Player.xpos + 10
    Player.bottomy = Player.ypos + Player.Height - 10
    Player.bottomWidth = Player.Width - 20
    Player.bottomHeight = 10
    -- right hitbox
    Player.rightx = Player.xpos + Player.Width - 10
    Player.righty = Player.ypos + 10
    Player.rightWidth = 10
    Player.rightHeight = Player.Height - 20
    -- left hitbox
    Player.leftx = Player.xpos
    Player.lefty = Player.ypos + 10
    Player.leftWidth = 10
    Player.leftHeight = Player.Height - 20
end

function Player:update(dt)
    UpdateAll()
    Player.ypos = Player.ypos + Player.Gravity * dt
    Player.Gravity = Player.Gravity + 1200 * dt
    if love.keyboard.isDown("up") and Player.isJumping == false and Player.isonPlatform then
        Player.Gravity = -625
        Player.isJumping = true
    end
    UpdateAll()
    if love.keyboard.isDown("left") then
        Player.xpos = Player.xpos - Player.Speed * dt
    end
    UpdateAll()
    if love.keyboard.isDown("right") then
        Player.xpos = Player.xpos + Player.Speed * dt
    end
    UpdateAll()
    if love.keyboard.isDown("down") then
        UpdateAll()
        Player.collisionThin = false
        UpdateAll()
        if Player.Gravity < 900 then
            UpdateAll()
            Player.Gravity = 900
            UpdateAll()
        end
        UpdateAll()
    else
        UpdateAll()
        Player.collisionThin = true
        UpdateAll()
    end
    UpdateAll()
end

function Player:draw()
    love.graphics.draw(Player.Image, Player.xpos, Player.ypos)
    --[[love.graphics.rectangle("fill", Player.topx, Player.topy, Player.topWidth, Player.topHeight)
    love.graphics.rectangle("fill", Player.bottomx, Player.bottomy, Player.bottomWidth, Player.bottomHeight)
    love.graphics.rectangle("fill", Player.leftx, Player.lefty, Player.leftWidth, Player.leftHeight)
    love.graphics.rectangle("fill", Player.rightx, Player.righty, Player.rightWidth, Player.rightHeight)]]
end

-- collisions and shit-----------------------------------------------
function Player:collide(x, y, w, h)
    if checkCollision(Player.xpos, Player.ypos, Player.Width, Player.Height, x, y, w, h) then
        return true
    else
        return false
    end
end

function Player:bottomCollide(x, y, w, h)
    if checkCollision(Player.bottomx, Player.bottomy, Player.bottomWidth, Player.bottomHeight, x, y, w, h) then
        return true
    else
        return false
    end
end

function Player:topCollide(x, y, w, h)
    if checkCollision(Player.topx, Player.topy, Player.topWidth, Player.topHeight, x, y, w, h) then
        return true
    else
        return false
    end
end

function Player:leftCollide(x, y, w, h)
    if checkCollision(Player.leftx, Player.lefty, Player.leftWidth, Player.leftHeight, x, y, w, h) then
        return true
    else
        return false
    end
end

function Player:rightCollide(x, y, w, h)
    if checkCollision(Player.rightx, Player.righty, Player.rightWidth, Player.rightHeight, x, y, w, h) then
        return true
    else
        return false
    end
end

-- collisions and shit-----------------------------------------------
function FloorCollide()
    if Player:bottomCollide(Floor.xpos, Floor.ypos, Floor.Width, Floor.Height) and Level == 1 then
        Player.Gravity = 0
        Player.ypos = Floor.ypos - Player.Height
        Player.isJumping = false
        return true
    else
        return false
    end
end

function UpdateAll()
    Player:bounds()
    Player:updateHits()
    FloorCollide()
    Player:collidePlatform_1("left")
    Player:collidePlatform_1("right")
    Player:collidePlatform_1("bottom")
    Player:collidePlatform_1("top")
    Player:collidePlatform_2("left")
    Player:collidePlatform_2("right")
    Player:collidePlatform_2("bottom")
    Player:collidePlatform_2("top")
    Player:collidePlatform_3("left")
    Player:collidePlatform_3("right")
    Player:collidePlatform_3("bottom")
    Player:collidePlatform_3("top")
    Player:collideThin_1()
    Player:collideBoost_1()
    Player:collideLong_1()
    Player:isonthePlatforms()
    Player:bounds()
end

function Player:isonthePlatforms()
    if Player.Gravity < 1 and Player.Gravity > -1 then
        Player.isonPlatform = true
    else
        Player.isonPlatform = false
    end
end

function Player:updateHits()
    Player.topx = Player.xpos + 10
    Player.topy = Player.ypos
    Player.bottomx = Player.xpos + 10
    Player.bottomy = Player.ypos + Player.Height - 10
    Player.rightx = Player.xpos + Player.Width - 10
    Player.righty = Player.ypos + 10
    Player.leftx = Player.xpos
    Player.lefty = Player.ypos + 10
    Player.RightSwordx = Player.xpos + Player.Width
    Player.RightSwordy = Player.ypos
    Player.LeftSwordx = Player.xpos - 20
    Player.LeftSwordy = Player.ypos
end

-- bounds and level progression
--[[function Player:bounds()
    if Player.boundDirection == "up" then
        Player:bottomBlock(2, -1)
        Player:topBlock(2, 1)
        Player:rightBlock()
        Player:leftBlock()
    elseif Player.boundDirection == "down" then
        Player:bottomBlock(2, 1)
        Player:topBlock(2, -1)
        Player:rightBlock()
        Player:leftBlock()
    elseif Player.boundDirection == "left" then
        Player:bottomBlock()
        Player:topBlock()
        Player:rightBlock(2, -1)
        Player:leftBlock(2, 1)
    elseif Player.boundDirection == "right" then 
        Player:bottomBlock()
        Player:topBlock()
        Player:rightBlock(2, 1)
        Player:leftBlock(2, -1)
    end
    -- level stuff
    if Level < 10 and Level ~= 10 then 
        Player.boundDirection = "up"
    elseif Level == 10 then 
        Player.boundDirection = "special"
        Player:bottomBlock(2, -1)
        Player:topBlock()
        Player:rightBlock(2, 1)
        Player:leftBlock()
    elseif Level > 10 and Level ~= 10 then 
        Player.boundDirection = "right"
    end
    --[[if Level > 0 then 
        if Level < 10 and Level ~= 10 then 
            Player.boundDirection = "up"
        end
        if Level == 10 then 
            Player.boundDirection = "special"
            Player:bottomBlock(2, -1)
            Player:topBlock()
            Player:rightBlock(2, 1)
            Player:leftBlock()
        end
        if Level > 10 and Level ~= 10 then 
            Player.boundDirection = "right"
        end
    end]]
--end

function Player:rightBlock(mode, change)
    if mode == nil then
        mode = 1
    end
    if change == nil then
        change = 0
    end
    if Player.xpos + Player.Width > Width and mode == 1 then
        Player.xpos = Width - Player.Width
    end
    if Player.xpos + Player.Width > Width and mode == 2 then
        Player.xpos = 0
        Level = Level + change
    end
end

function Player:leftBlock(mode, change)
    if mode == nil then
        mode = 1
    end
    if change == nil then
        change = 0
    end
    if Player.xpos < 0 and mode == 1 then
        Player.xpos = 0
    elseif Player.xpos < 0 then
        Player.xpos = Width - Player.Width
        Level = Level + change
    end
end

function Player:topBlock(mode, change)
    if mode == nil then
        mode = 1
    end
    if change == nil then
        change = 0
    end
    if Player.ypos < 0 and mode == 1 then
        Player.ypos = 0
    elseif Player.ypos < 0 and mode == 2 then
        Player.ypos = Height - Player.Height
        Level = Level + change
        Player.ypos = Height - Player.Height
    end
end

function Player:bottomBlock(mode, change)
    if mode == nil then
        mode = 1
    end
    if change == nil then
        change = 0
    end
    if Player.ypos + Player.Height > Height and mode == 1 then
        Player.ypos = Height - Player.Height
    end
    if Player.ypos + Player.Height > Height and mode == 2 then
        Player.ypos = 0
        Level = Level + change
        Player.ypos = 0
    end
end

-- if colliding with platform 1 or something
function Player:collidePlatform_1(side)
    if side == "top" then
        if Player:bottomCollide(Platform_1.xpos, Platform_1.ypos, Platform_1.Width, Platform_1.Height) then
            Player.ypos = Platform_1.ypos - Player.Height
            Player.Gravity = 0
            Player.isJumping = false
            return true
        else
            return false
        end
    end
    if side == "left" then
        if Player:rightCollide(Platform_1.leftx, Platform_1.lefty, Platform_1.leftWidth, Platform_1.leftHeight) then
            Player.xpos = Platform_1.xpos - Player.Width
            return true
        else
            return false
        end
    end
    if side == "right" then
        if Player:leftCollide(Platform_1.rightx, Platform_1.righty, Platform_1.rightWidth, Platform_1.rightHeight) then
            Player.xpos = Platform_1.xpos + Platform_1.Width
        end
    end
    if side == "bottom" then
        if Player:topCollide(Platform_1.bottomx, Platform_1.bottomy, Platform_1.bottomWidth, Platform_1.bottomHeight) then
            Player.ypos = Platform_1.ypos + Platform_1.Height
            Player.Gravity = 0
        end
    end
end

-- if colliding with platform 2 or someThin_1g im so tired and it is only 7:30 PM
function Player:collidePlatform_2(side)
    if side == "top" then
        if Player:bottomCollide(Platform_2.xpos, Platform_2.ypos, Platform_2.Width, Platform_2.Height) then
            Player.ypos = Platform_2.ypos - Player.Height
            Player.Gravity = 0
            Player.isJumping = false
            return true
        else
            return false
        end
    end
    if side == "left" then
        if Player:rightCollide(Platform_2.leftx, Platform_2.lefty, Platform_2.leftWidth, Platform_2.leftHeight) then
            Player.xpos = Platform_2.xpos - Player.Width
            return true
        else
            return false
        end
    end
    if side == "right" then
        if Player:leftCollide(Platform_2.rightx, Platform_2.righty, Platform_2.rightWidth, Platform_2.rightHeight) then
            Player.xpos = Platform_2.xpos + Platform_2.Width
        end
    end
    if side == "bottom" then
        if Player:topCollide(Platform_2.bottomx, Platform_2.bottomy, Platform_2.bottomWidth, Platform_2.bottomHeight) then
            Player.ypos = Platform_2.ypos + Platform_2.Height
            Player.Gravity = 0
        end
    end
end

-- if colliding with platform 3 or someThin_1g i moved to a new computer and i am tired of installing extentions again so it looks the way it was before
function Player:collidePlatform_3(side)
    if side == "top" then
        if Player:bottomCollide(Platform_3.xpos, Platform_3.ypos, Platform_3.Width, Platform_3.Height) then
            Player.ypos = Platform_3.ypos - Player.Height
            Player.Gravity = 0
            Player.isJumping = false
            return true
        else
            return false
        end
    end
    if side == "left" then
        if Player:rightCollide(Platform_3.leftx, Platform_3.lefty, Platform_3.leftWidth, Platform_3.leftHeight) then
            Player.xpos = Platform_3.xpos - Player.Width
            return true
        else
            return false
        end
    end
    if side == "right" then
        if Player:leftCollide(Platform_3.rightx, Platform_3.righty, Platform_3.rightWidth, Platform_3.rightHeight) then
            Player.xpos = Platform_3.xpos + Platform_3.Width
        end
    end
    if side == "bottom" then
        if Player:topCollide(Platform_3.bottomx, Platform_3.bottomy, Platform_3.bottomWidth, Platform_3.bottomHeight) then
            Player.ypos = Platform_3.ypos + Platform_3.Height
            Player.Gravity = 0
        end
    end
end

-- if colliding with the Thin Platforms
function Player:collideThin_1()
    if Player:bottomCollide(Thin_1.xpos, Thin_1.ypos, Thin_1.Width, Thin_1.Height) and Player.Gravity > 10 and Player.collisionThin then
        Player.ypos = Thin_1.ypos - Player.Height
        Player.Gravity = 0
        Player.isJumping = false
    end
    if Player:bottomCollide(Thin_1.xpos, Thin_1.ypos, Thin_1.Width, Thin_1.Height) then
        Player.isCollidingWithThin = true
        return true
    else
        Player.isCollidingWithThin = false
        return false
    end
end

function Player:collideThin_2()
    if Player:bottomCollide(Thin_2.xpos, Thin_2.ypos, Thin_2.Width, Thin_2.Height) and Player.Gravity > 10 and Player.collisionThin then
        Player.ypos = Thin_2.ypos - Player.Height
        Player.Gravity = 0
        Player.isJumping = false
    end
    if Player:bottomCollide(Thin_2.xpos, Thin_2.ypos, Thin_2.Width, Thin_2.Height) then
        Player.isCollidingWithThin = true
        return true
    else
        Player.isCollidingWithThin = false
        return false
    end
end

function Player:collideThin_3()
    if Player:bottomCollide(Thin_3.xpos, Thin_3.ypos, Thin_3.Width, Thin_3.Height) and Player.Gravity > 10 and Player.collisionThin then
        Player.ypos = Thin_3.ypos - Player.Height
        Player.Gravity = 0
        Player.isJumping = false
    end
    if Player:bottomCollide(Thin_3.xpos, Thin_3.ypos, Thin_3.Width, Thin_3.Height) then
        Player.isCollidingWithThin = true
        return true
    else
        Player.isCollidingWithThin = false
        return false
    end
end

-- if colliding with the Boost_1 Boosters
function Player:collideBoost_1()
    if Player:collide(Boost_1.xpos, Boost_1.ypos, Boost_1.Width, Boost_1.Height) then
        Player.Gravity = -500
    end
end

-- if colliding with long platforms
function Player:collideLong_1()
    if Player:bottomCollide(Long_1.xpos, Long_1.ypos, Long_1.Width, Long_1.Height) and Player.Gravity > 10 and Player.collisionThin then
        Player.ypos = Long_1.ypos - Player.Height
        Player.Gravity = 0
        Player.isJumping = false
    end
    if Player:bottomCollide(Long_1.xpos, Long_1.ypos, Long_1.Width, Long_1.Height) then
        Player.isCollidingWithThin = true
        return true
    else
        Player.isCollidingWithThin = false
        return false
    end
end